(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("./src/util");
const schema_1 = require("./src/schema");
const parser_1 = require("./src/parser");
var schema_2 = require("./src/schema");
exports.parseSchema = schema_2.parseSchema;
function parse(source, schema, options = {}) {
    if (options.vars && Object.keys(options.vars).length === 0) {
        delete options.vars;
    }
    try {
        var statements = parser_1.lex(source, new util_1.Pos());
        return parser_1.parseZaml(source, typeof schema === 'string' ? schema_1.parseSchema(schema) : schema, statements, options);
    }
    catch (e) {
        if (e instanceof util_1.ZamlError) {
            e.addSource(source);
        }
        throw e;
    }
}
exports.parse = parse;

},{"./src/parser":2,"./src/schema":3,"./src/util":4}],2:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("./util");
function lex(source, pos, inBlock = false) {
    var results = [];
    while (pos.i < source.length) {
        let i = pos.i;
        let c = source[i];
        if (c === '}') {
            if (!inBlock) {
                throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c));
            }
            return results;
        }
        // Handle whitespace
        if (pos.skipWhitespace(source)) {
            continue;
        }
        // Comments
        if (c === '#') {
            while (pos.i < source.length && source[pos.i] !== '\n') {
                pos.newcol();
            }
            continue;
        }
        // Reserve key operators
        if (util_1.reservedOps.test(c)) {
            throw new util_1.ZamlError('syntax-error', pos, `Character ${c} is reserved for key names`);
        }
        // Whitelist errors
        if (util_1.brackets.test(c)) {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c));
        }
        // Special character escapes
        if (c === '\\' && source[pos.i + 1] === '$') {
            // Skip ahead one char, effectively removing the backslash from the key name.
            pos.newcol();
        }
        //
        // Begin statement
        //
        let statementPos = pos.copy();
        let name = readWord(source, pos);
        while (pos.i < source.length && pos.skipSpace(source)) { }
        let argsPosStart = pos.copy();
        //
        // Read rest of the line
        //
        let argsPosEnd = argsPosStart;
        while (pos.i < source.length) {
            let c2 = source[pos.i];
            if (c2 === '\n') {
                argsPosEnd = pos.copy();
                pos.newline(source[pos.i + 1] === '\r');
                break;
            }
            else {
                pos.newcol();
            }
        }
        if (pos.i === source.length) {
            argsPosEnd = pos.copy();
        }
        let hasBlock = source[argsPosEnd.i - 1] === '{';
        if (hasBlock) {
            // Backtrack
            argsPosEnd.i -= 1;
            argsPosEnd.col -= 1;
        }
        let args = source.substring(argsPosStart.i, argsPosEnd.i).replace(util_1.trailingWhitespace, '');
        let s = {
            pos: statementPos,
            type: 'pre-statement',
            name: name,
            args: args,
            argsPos: [argsPosStart, argsPosEnd],
        };
        if (hasBlock) {
            s.block = lex(source, pos, true);
            if (pos.i === source.length) {
                throw new util_1.ZamlError('syntax-error', pos, `Unexpected EOF: Missing end bracket '}'`);
            }
            if (source[pos.i] !== '}') {
                throw new util_1.ZamlError('syntax-error', pos, `Expected end bracket '}', got ${JSON.stringify(source[pos.i])} instead (shouldn't be possible?)`);
            }
            pos.newcol();
        }
        results.push(s);
    }
    return results;
}
exports.lex = lex;
function parseZaml(source, blockSchema, statements, opts) {
    var result = blockSchema.type === 'array' ? [] : {};
    if (blockSchema.type === 'hash') {
        for (let name in blockSchema.schema) {
            if (blockSchema.schema[name].multi) {
                result[name] = [];
            }
        }
    }
    for (var i = 0; i < statements.length; i++) {
        const s = statements[i];
        const name = s.name;
        const t = blockSchema.schema[name];
        if (!t) {
            throw new util_1.ZamlError('user-error', s.pos, `No such config key: ${name}`);
        }
        let parsedValue;
        if (t.type === 'num') {
            let num = Number(withVars(s.args, s.pos, opts));
            if (Number.isNaN(num)) {
                throw new util_1.ZamlError('user-error', s.argsPos[0], `Invalid number: '${s.args}'`);
            }
            parsedValue = num;
        }
        else if (t.type === 'str') {
            parsedValue = withVars(s.args, s.pos, opts);
        }
        else if (t.type === 'enum') {
            parsedValue = withVars(s.args, s.pos, opts);
            if (t.options.indexOf(parsedValue) === -1) {
                throw new util_1.ZamlError('user-error', s.argsPos[0], `Invalid value: '${parsedValue}'\n  Value must be one of: ${t.options.join(', ')}`);
            }
        }
        else if (t.type === 'bool') {
            let val = withVars(s.args, s.pos, opts);
            if (val === '') {
                throw new util_1.ZamlError('user-error', s.argsPos[0], `Boolean '${val} requires a value.'`);
            }
            if (val !== 'true' && val !== 'false') {
                throw new util_1.ZamlError('user-error', s.argsPos[0], `Invalid boolean: '${val}'. Value must be true or false.`);
            }
            parsedValue = val === 'true';
        }
        else if (t.type === 'list') {
            if (s.block) {
                // Block list
                if (s.args.length > 0) {
                    throw new util_1.ZamlError('user-error', s.argsPos[0], listFormatError);
                }
                let list = [];
                for (let s2 of s.block) {
                    if (t.block) {
                        let str = withVars(s2.name, s2.pos, opts);
                        list.push(s2.block ? [str, parseZaml(source, t.block, s2.block, opts)] : [str]);
                    }
                    else if (s2.block) {
                        throw new util_1.ZamlError('user-error', s2.argsPos[0], `The '${s.name}' list does not accept a block.`);
                    }
                    else {
                        list.push(withVars(s2.name + (s2.args.length ? ` ${s2.args}` : ''), s2.pos, opts));
                    }
                }
                parsedValue = list;
            }
            else {
                // Inline list
                parsedValue = parseArgs(source, s.argsPos[0], s.argsPos[1], opts);
            }
        }
        else if (t.type === 'kv') {
            var hash = {};
            if (s.block) {
                for (let s2 of s.block) {
                    if (s2.args === '') {
                        throw new util_1.ZamlError('user-error', s2.argsPos[0], `Hash key '${s2.name}' requires a value.`);
                    }
                    hash[withVars(s2.name, s2.pos, opts)] = withVars(s2.args, s2.argsPos[0], opts);
                }
            }
            parsedValue = hash;
        }
        else if (t.type === 'hash' || t.type === 'array') {
            if (!s.block) {
                throw new util_1.ZamlError('user-error', s.pos, `Key '${s.name}' requires a block.`);
            }
            parsedValue = parseZaml(source, t, s.block, opts);
        }
        else if (t.type === 'tuple') {
            let args = parseArgs(source, s.argsPos[0], s.argsPos[1], opts, (arg, k, pos) => {
                if (k >= t.schema.length) {
                    let types = t.schema.map(t => t.type).join(' ');
                    throw new util_1.ZamlError('user-error', pos, `Too many arguments; tuple only accepts ${types}`);
                }
                let t2 = t.schema[k];
                //
                // No need to transform with withVars at this point since
                // parseArgs has already done so.
                //
                if (t2.type === 'num') {
                    return Number(arg);
                }
                else if (t2.type === 'str') {
                    return arg;
                }
                else if (t2.type === 'bool') {
                    if (arg !== 'true' && arg !== 'false') {
                        throw new util_1.ZamlError('user-error', pos, `Invalid boolean: '${arg}'. Value must be true or false.`);
                    }
                    return arg === 'true';
                }
                else {
                    throw new util_1.ZamlError('unexpected-error', pos, `Invalid tuple type '${JSON.stringify(t2)}' for arg '${JSON.stringify(arg)}' (Shouldn't be possible)`);
                }
            });
            if (args.length !== t.schema.length) {
                let types = t.schema.map(t => t.type).join(', ');
                throw new util_1.ZamlError('user-error', s.pos, `Incorrect number of arguments. Key '${s.name}' expects ${types}.`);
            }
            parsedValue = args;
        }
        else {
            throw new util_1.ZamlError('unexpected-error', null, `Invalid type object (${JSON.stringify(t)})`);
        }
        //
        // Handle blocks
        //
        if (s.block && util_1.BLOCKABLE_TYPES.indexOf(t.type) >= 0 && t.type !== 'list') {
            let innerBlockSchema = ('block' in t) && t.block;
            if (!innerBlockSchema) {
                throw new util_1.ZamlError('user-error', s.argsPos[1], `Key ${s.name} does not accept a block.`);
            }
            else {
                parsedValue = [parsedValue, parseZaml(source, innerBlockSchema, s.block, opts)];
            }
        }
        if (blockSchema.type === 'array') {
            result.push([name, parsedValue]);
        }
        else if (t.multi) {
            result[name].push(parsedValue);
        }
        else {
            if (name in result) {
                throw new util_1.ZamlError('user-error', s.pos, `Duplicate key '${name}'. This key may only be specified once in this context.`);
            }
            result[name] = parsedValue;
        }
    }
    return result;
}
exports.parseZaml = parseZaml;
function parseQuotedString(source, pos, end) {
    var start = pos.copy();
    // TODO: Support backslash quotes
    while (pos.i < end.i && source[pos.i] !== '"') {
        if (pos.skipNewline(source)) {
            throw new util_1.ZamlError('syntax-error', pos, `Newlines are not allowed in quoted strings`);
        }
        pos.newcol();
    }
    if (pos.i === end.i) {
        throw new util_1.ZamlError('syntax-error', start, `Unexpected EOF: Missing end quote`);
    }
    var str = source.substring(start.i, pos.i);
    pos.newcol(); // Skip end quote character
    return str;
}
function parseArgs(source, start, end, opts, map = id) {
    var args = [];
    var pos = start.copy();
    while (pos.i < end.i) {
        let c = source[pos.i];
        // Quoted string
        if (c === '"') {
            let start = pos.copy();
            let arg = parseQuotedString(source, pos.newcol(), end);
            args.push(map(withVars(arg, start, opts), args.length, start));
        }
        // Unquoted string
        else {
            let start = pos.copy();
            while (pos.i < end.i && source[pos.i] !== ',' && source[pos.i] !== '\n') {
                pos.newcol();
            }
            let arg = source.substring(start.i, pos.i).trim();
            args.push(map(withVars(arg, start, opts), args.length, start));
        }
        while (pos.skipSpace(source)) { }
        let c2 = source[pos.i];
        if (c2 === '\n' || c2 === '{' && source[pos.i + 1] === '\n') {
            return args;
        }
        if (c2 === ',') {
            let commaPos = pos.copy();
            pos.newcol();
            while (pos.skipSpace(source)) { }
            if (pos.i === source.length || source[pos.i] === '\n') {
                throw new util_1.ZamlError('syntax-error', commaPos, `Unexpected comma`);
            }
            continue;
        }
        throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c2, ' (did you forget a comma?)'));
    }
    return args;
}
function readWord(source, pos) {
    var start = pos.i;
    while (pos.i < source.length && !util_1.whitespace.test(source[pos.i])) {
        pos.newcol();
    }
    return source.substring(start, pos.i);
}
function withVars(str, origin, opts) {
    if (!opts.vars)
        return str;
    return str.replace(/\$([a-zA-Z_][a-zA-Z0-9_]*)/g, (_match, varName) => {
        var val = opts.vars[varName];
        if (!val && opts.failOnUndefinedVars === true) {
            throw new util_1.ZamlError('user-error', origin, `Variable '$${varName}' is not defined.`);
        }
        return val || '';
    });
}
function id(x) { return x; }
const listFormatError = `You may provide a block or inline arguments to a list, but not both.
Examples:
  ✓ a_list x y z
  ✓ a_list {
      x
      y
      z
    }
`;

},{"./util":4}],3:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
//
// Zaml schemas are deliberately non whitespace sensitive.
// The strategy to accomplish this is for each token to
// take care of their own trailing spaces.
//
const util_1 = require("./util");
function parseSchema(source) {
    try {
        var pos = new util_1.Pos();
        while (pos.skipWhitespace(source)) { }
        var startChar = source[pos.i];
        if (startChar !== '{' && startChar !== '[') {
            throw new util_1.ZamlError('syntax-error', pos, `Your schema must begin with a hash block "{" or an array block "["`);
        }
        return parseBlock(source, pos);
    }
    catch (e) {
        if (e instanceof util_1.ZamlError) {
            e.addSource(source);
        }
        throw e;
    }
}
exports.parseSchema = parseSchema;
function parseBlock(source, pos) {
    const start = pos.copy();
    const blockChar = source[pos.i];
    if (blockChar !== '{' && blockChar !== '[') {
        throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(blockChar, "This shouldn't happen."));
    }
    const endBlockChar = blockChar === '{' ? '}' : ']';
    const result = blockChar === '{'
        ? { type: 'hash', schema: {} }
        : { type: 'array', schema: {} };
    pos.newcol();
    while (pos.skipWhitespace(source)) { }
    while (pos.i < source.length) {
        var keyStart = pos.copy();
        var key = readKey(source, pos);
        while (pos.skipWhitespace(source)) { }
        if (key.name !== '') {
            if (result.schema[key.name]) {
                throw new util_1.ZamlError('user-error', keyStart, `Duplicate key: "${key.name}" has already been defined in this context.`);
            }
            var type = readType(source, pos);
            if (key.multi)
                type.multi = true;
            result.schema[key.name] = type;
        }
        while (pos.skipWhitespace(source)) { }
        var c = source[pos.i];
        if (c === '}' || c === ']') {
            if (c !== endBlockChar) {
                throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c));
            }
            pos.newcol();
            while (pos.skipWhitespace(source)) { }
            return result;
        }
        else if (c === ',') {
            pos.newcol();
            while (pos.skipWhitespace(source)) { }
        }
        else if (pos.i < source.length) {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c));
        }
    }
    if (pos.i === source.length) {
        throw new util_1.ZamlError('syntax-error', start, `Missing end bracket "${endBlockChar}"`);
    }
    return result;
}
function readKey(source, pos) {
    var start = pos.i;
    while (pos.i < source.length &&
        source[pos.i] !== '{' &&
        source[pos.i] !== '}' &&
        source[pos.i] !== '[' &&
        source[pos.i] !== ']' &&
        source[pos.i] !== '(' &&
        source[pos.i] !== ')' &&
        source[pos.i] !== ',' &&
        source[pos.i] !== ':' &&
        !util_1.whitespace.test(source[pos.i])) {
        pos.newcol();
    }
    var key = source.substring(start, pos.i);
    let [name, ...attrs] = key.split('|');
    var result = { name };
    if (attrs.indexOf('multi') >= 0)
        result.multi = true;
    return result;
}
function readEnum(source, pos) {
    var start = pos.i;
    while (pos.i < source.length &&
        source[pos.i] !== '(' &&
        source[pos.i] !== ')' &&
        source[pos.i] !== ',' &&
        source[pos.i] !== ':') {
        pos.newcol();
    }
    return source.substring(start, pos.i).trim();
}
function readType(source, pos) {
    let c = source[pos.i];
    if (pos.i >= source.length || c === '}' || c === ']' || c === ',') {
        // At this point we've reached the end without
        // a specified type. Return the default.
        return { type: 'str' };
    }
    if (c === '{' || c === '[' || c === '(') {
        throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c, '. Did you forget a colon?'));
    }
    if (c === ':') {
        pos.newcol();
        while (pos.skipWhitespace(source)) { }
        let c2 = source[pos.i];
        if (c2 === '{' || c2 === '[') {
            return parseBlock(source, pos);
        }
        if (c2 === '(') {
            var tuplePos = pos.copy();
            pos.newcol(); // Skip open parens
            while (pos.skipWhitespace(source)) { }
            var types = readTupleTypes(source, pos, tuplePos);
            if (types.length < 2) {
                throw new util_1.ZamlError('user-error', tuplePos, `A tuple requires at least two types (${types.length ? 'onle one was' : 'none were'} provided).`);
            }
            while (pos.skipWhitespace(source)) { }
            if (source[pos.i] === '{') {
                let block = parseBlock(source, pos);
                return { type: 'tuple', schema: types, block };
            }
            else {
                return { type: 'tuple', schema: types };
            }
        }
        let typenamePos = pos.copy();
        let { name: typename } = readKey(source, pos);
        while (pos.skipWhitespace(source)) { }
        if (util_1.validTypes.indexOf(typename) === -1) {
            throw new util_1.ZamlError('user-error', typenamePos, `No such type: '${typename}'`);
        }
        if (typename === 'enum') {
            if (source[pos.i] !== '(') {
                throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(source[pos.i], ' (Did you forget a parenthesis?)'));
            }
            pos.newcol();
            while (pos.skipWhitespace(source)) { }
            var options = [];
            while (pos.i < source.length) {
                var option = readEnum(source, pos);
                if (option !== '') {
                    options.push(option);
                }
                while (pos.skipWhitespace(source)) { }
                if (source[pos.i] === ',') {
                    pos.newcol();
                    while (pos.skipWhitespace(source)) { }
                }
                else if (source[pos.i] === ')') {
                    pos.newcol();
                    while (pos.skipWhitespace(source)) { }
                    break;
                }
                else {
                    throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(source[pos.i]));
                }
            }
            if (options.length === 0) {
                throw new util_1.ZamlError('user-error', typenamePos, 'An enum type must have at least one option.');
            }
            if (source[pos.i] === '{' || source[pos.i] === '[') {
                let block = parseBlock(source, pos);
                return { type: typename, options, block };
            }
            else {
                return { type: typename, options };
            }
        }
        let c3 = source[pos.i];
        if (c3 === '{' || c3 === '[') {
            if (util_1.BLOCKABLE_TYPES.indexOf(typename) === -1) {
                throw new util_1.ZamlError('user-error', pos, `A '${typename}' type may not have a block.`);
            }
            let block = parseBlock(source, pos);
            return { type: typename, block };
        }
        else if (c3 === ',' || c3 === '}' || c3 === ']' || pos.i === source.length) {
            return { type: typename };
        }
        throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(source[pos.i]));
    }
    else {
        throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(source[pos.i]));
    }
    return { type: 'str' };
}
function readTupleTypes(source, pos, openParenPos) {
    var types = [];
    while (pos.i < source.length) {
        let c = source[pos.i];
        if (c === ':' || c === '(') {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c));
        }
        let namePos = pos.copy();
        let { name } = readKey(source, pos);
        while (pos.skipWhitespace(source)) { }
        if (name !== '') {
            let type = util_1.basicTypeFromName(name);
            if (!type) {
                throw new util_1.ZamlError('user-error', namePos, `Invalid tuple type '${name}'. Tuples may only contain str, num, and bool.`);
            }
            types.push(type);
        }
        let c2 = source[pos.i];
        if (c2 === ',') {
            pos.newcol();
            while (pos.skipWhitespace(source)) { }
            continue;
        }
        if (c2 === ')') {
            pos.newcol();
            return types;
        }
        if (c2 === '{') {
            throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c2, ' (blocks are not allowed within a tuple type)'));
        }
        var hint = c2.match(/[a-z0-9]/i) ? ' (did you forget a comma?)' : '';
        throw new util_1.ZamlError('syntax-error', pos, util_1.unexp(c2, hint));
    }
    throw new util_1.ZamlError('syntax-error', openParenPos, `Missing end parenthesis ")"`);
}

},{"./util":4}],4:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
//
// Constants
//
exports.brackets = /[\(\)\{\}\[\]]/;
exports.whitespace = /[ \t\n\r]/;
exports.reservedOps = /[\^&#@~`]/;
exports.trailingWhitespace = /[ \t\n\r]*$/;
exports.validTypes = ['num', 'str', 'kv', 'list', 'bool', 'enum'];
exports.BLOCKABLE_TYPES = ['str', 'num', 'bool', 'tuple', 'list'];
function basicTypeFromName(name) {
    if (name === 'num' || name === 'str' || name === 'bool') {
        return { type: name };
    }
    return null;
}
exports.basicTypeFromName = basicTypeFromName;
class ZamlError extends Error {
    constructor(type, pos, message) {
        super(`[ZamlError] ${message}`);
        this.type = type;
        this.pos = pos;
    }
    static syntax(pos, char, more = '') {
        return new ZamlError('syntax-error', pos, `Unexpected '${char}'${more}`);
    }
    addSource(source) {
        if (!this.pos)
            return;
        var lines = source.split('\n');
        var { line, col } = this.pos;
        var lineNo = String(line);
        var prevLineNo = String(line - 1);
        if (lineNo.length > prevLineNo.length) {
            prevLineNo = spacer(lineNo.length - prevLineNo.length) + prevLineNo;
        }
        else if (prevLineNo.length > lineNo.length) {
            lineNo = spacer(prevLineNo.length - lineNo.length) + lineNo;
        }
        this.message =
            this.message + '\n' +
                `  on line ${line} col ${col}\n\n` +
                (line > 1 ? `  ${prevLineNo}│ ${lines[line - 2]}\n` : '') +
                `  ${lineNo}│ ${lines[line - 1]}\n  ${spacer(col - 1 + lineNo.length + 2)}^`;
    }
}
exports.ZamlError = ZamlError;
//
// Helpers
//
function isObj(x) {
    return Object.prototype.toString.call(x) === '[object Object]';
}
exports.isObj = isObj;
function unexp(char, more = '') {
    return `Unexpected ${JSON.stringify(char)}${more}`;
}
exports.unexp = unexp;
function range(start, end) {
    var result = [];
    for (var i = start; i < end; i++)
        result.push(i);
    return result;
}
function spacer(length) {
    return range(0, length).map(_ => ' ').join('');
}
class Pos {
    constructor(line = 1, col = 1, i = 0) {
        this.line = line;
        this.col = col;
        this.i = i;
    }
    push(source) {
        this.skipNewline(source) || this.newcol();
        return this;
    }
    newcol() {
        this.i += 1;
        this.col += 1;
        return this;
    }
    newline(windowsLine = false) {
        this.i += (windowsLine ? 2 : 1);
        this.col = 1;
        this.line += 1;
    }
    copy() {
        return new Pos(this.line, this.col, this.i);
    }
    skipSpace(source) {
        if (source[this.i] === ' ' || source[this.i] === '\t') {
            this.newcol();
            return true;
        }
        return false;
    }
    skipNewline(source) {
        if (source[this.i] === '\n') {
            this.newline(source[this.i + 1] === '\r');
            return true;
        }
        return false;
    }
    skipWhitespace(source) {
        if (this.i >= source.length)
            return false;
        return this.skipSpace(source) || this.skipNewline(source);
    }
}
exports.Pos = Pos;

},{}],5:[function(require,module,exports){
window.Zaml = require('./dist/index.js')

},{"./dist/index.js":1}]},{},[5]);
