"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const util_1 = require("./src/util");
const schema_1 = require("./src/schema");
const parser_1 = require("./src/parser");
var schema_2 = require("./src/schema");
exports.parseSchema = schema_2.parseSchema;
function parse(source, schema, options = {}) {
    if (options.vars && Object.keys(options.vars).length === 0) {
        delete options.vars;
    }
    try {
        var statements = parser_1.lex(source, new util_1.Pos());
        return parser_1.parseZaml(source, typeof schema === 'string' ? schema_1.parseSchema(schema) : schema, statements, options);
    }
    catch (e) {
        if (e instanceof util_1.ZamlError) {
            e.addSource(source);
        }
        throw e;
    }
}
exports.parse = parse;
