import { Pos, Schema } from './util';
declare type Statement = {
    pos: Pos;
    type: 'pre-statement';
    name: string;
    args: string;
    argsPos: [Pos, Pos];
    block?: Statement[];
};
declare type ParseResult = any;
export declare type ParseOptions = {
    /** Variables to make available for interpolation within Zaml source code. */
    vars?: Record<string, string>;
    /** If set to true, parsing will fail when a user tries to use a variable that does not exist. */
    failOnUndefinedVars?: boolean;
};
export declare function lex(source: string, pos: Pos, inBlock?: boolean): Statement[];
export declare function parseZaml(source: string, blockSchema: Schema.Block, statements: Statement[], opts: ParseOptions): ParseResult;
export {};
